/*
 ķ
   Program..: _DCTOKEN.PRG                                 
   Author...: Roger J. Donnay                              
   Notice...: (c) DONNAY Software Designs 1987-2000        
   Date.....: Mar 17, 2000                                 
   Notes....: dCLIP Token functions                        
                                                           
   Functions:  dc_token(), dc_tokennum(), dc_fillchar()    
               dc_tokenjustify()                           
 Ľ
*/

#pragma Ansi2Oem(OFF)

#INCLUDE "dcdialog.CH"

STATIC nFillChar := 32

FUNCTION dc_token ( cString, cDelims, nOccur, lQuote )

LOCAL aTokens := DC_TokenArray( cString, cDelims, lQuote )

IF Empty(aTokens) .OR. nOccur > LEN(aTokens)
  RETURN ''
ENDIF
RETURN aTokens[nOccur]

/* ----------------------- */

/*
FUNCTION dc_tokennum ( cString, cDelims )

LOCAL nStringLen, nHit, cSubString, i, cChar

cString := IIF(Valtype(cString)='C',cString,'')
cDelims := IIF(Valtype(cDelims)='C',cDelims, _DCTokenDelims() )
IF !(SubStr(cString,1,1)$cDelims)
  cString := SubStr(cDelims,1,1) + cString
ENDIF
nStringLen := LEN(cString)
nHit := 0
cSubString := ''
FOR i := 1 TO nStringLen
  cChar := SUBSTR(cString,i,1)
  IF cChar $ cDelims
    IF LEN(cSubString) > 0
      nHit++
      cSubString := ''
    ENDIF
  ELSE
    cSubString := cString + cChar
  ENDIF
NEXT
IF !( SUBSTR(cString,nStringLen,1) $ cDelims )
  nHit++
ENDIF
RETURN nHit
*/

/* ----------------------- */

FUNCTION dc_tokenjustify ( cString, cDelims, nWidth, nType )

LOCAL i, cFill, nDelims, nLength, cOutString, lDelim, cFillChar,;
      cChar, nLeft := 0, nRight := 0

cFillChar := CHR(DC_FillChar())
cString := IIF(Valtype(cString)='C',cString,'')
nWidth := IIF(Valtype(nWidth)='N',nWidth,0)
nType := IIF(Valtype(nType)='N',nType,0)
nWidth := Max(nWidth,LEN(cString))
cDelims := IIF(Valtype(cDelims)='C',cDelims, _DCTokenDelims() )
cString := _DCTokenTrim(cString,cDelims,@nLeft,@nRight)
cOutString := ''
lDelim := .f.
nDelims := 0
FOR i := 1 TO LEN(cString)
  cChar := SubStr(cString,i,1)
  IF cChar $ cDelims
    IF !lDelim
      cOutString += cFillChar
      nDelims++
      lDelim := .t.
    ENDIF
  ELSE
    cOutString += cChar
    lDelim := .f.
  ENDIF
NEXT
DO CASE
  CASE nType=0
    nLength := LEN(cOutString)
    cFill := REPL(cFillChar,(nWidth-(nLength-nDelims))/nDelims)
    cOutString := STRTRAN(cOutString,cFillChar,cFill)
    IF nWidth > LEN(cOutString)
      cOutString := ;
        STRTRAN(cOutString,cFill,cFill+cFillChar,1,nWidth-LEN(cOutString))
    ENDIF
  CASE nType=1 .OR. nType=2
    IF nType=1
      cOutString := REPL(cFillChar,nLeft) + cOutString
    ENDIF
    cOutString += REPL(cFillChar,nWidth-LEN(cOutString))
  CASE nType=3 .OR. nType=4
    IF nType=3
      cOutString += REPL(cFillChar,nRight)
    ENDIF
    cOutString := REPL(cFillChar,nWidth-LEN(cOutString)) + cOutString
ENDCASE
RETURN cOutString

/* ----------------------- */

/*
FUNCTION dc_tokenarray( cString, cDelims, lQuote )

LOCAL nFound, i, lStart, lDoubleQuoteOn, cInString, cChar, nCount := 0, ;
      aTokens[0], lSingleQuoteOn

DEFAULT lQuote := .f.

cDelims := IIF(Valtype(cDelims)='C',cDelims,_DCTokenDelims() )
IF EMPTY(cString)
  RETURN aTokens
ENDIF
IF lQuote
  lDoubleQuoteOn := .F.
  lSingleQuoteOn := .F.
  cInString := cString
  cString := ''
  FOR i := 1 TO Len(cInString)
    cChar := cInString[i]
    IF cChar == '"'
      lDoubleQuoteOn := !lDoubleQuoteOn
    ELSEIF cChar == "'" .AND. !lDoubleQuoteOn
      lSingleQuoteOn := !lSingleQuoteOn
    ELSEIF !lDoubleQuoteOn .AND. cChar $ cDelims .AND. !lSingleQuoteOn
      cChar := Chr(0)
    ENDIF
    cString += cChar
  NEXT
  cString := StrTran(cString,'"','')
ELSE
  FOR i := 1 TO LEN(cDelims)
    cString := Strtran(cString,SubStr(cDelims,i,1),CHR(0))
  NEXT
ENDIF
IF Len(cDelims) > 1
  IF CHR(0)+CHR(0) $ cString
    cString := StrTran(cString,CHR(0)+CHR(0),CHR(0))
  ENDIF
ENDIF
DO WHILE .t.
  nFound := AT(CHR(0),cString)
  IF nFound = 1 //.AND. Len(aTokens)=0
    AADD( aTokens,'' )
    cString := Substr(cString,2)
  ELSEIF nFound > 0
    AADD( aTokens, SubStr(cString,1,nFound-1) )
    cString := SubStr(cString,nFound+1)
  ELSE
    AADD( aTokens, cString )
    EXIT
  ENDIF
ENDDO
RETURN aTokens
*/

FUNCTION dc_tokenarray( cString, cDelims, lQuote )

LOCAL nFound, i, lStart, lDoubleQuoteOn, cInString, cChar, nCount := 0, ;
      aTokens[0], lSingleQuoteOn

DEFAULT lQuote := .f.

cDelims := IIF(Valtype(cDelims)='C',cDelims,_DCTokenDelims() )
IF EMPTY(cString)
  RETURN aTokens
ENDIF
IF lQuote
  lDoubleQuoteOn := .F.
  lSingleQuoteOn := .F.
  cInString := cString
  cString := ''
  FOR i := 1 TO Len(cInString)
    cChar := cInString[i]
    IF cChar == '"'
      lDoubleQuoteOn := !lDoubleQuoteOn
    ELSEIF cChar == "'"
      lSingleQuoteOn := !lSingleQuoteOn
    ELSEIF !lDoubleQuoteOn .AND. !lSingleQuoteOn .AND. cChar $ cDelims
      cChar := Chr(0)
    ENDIF
    cString += cChar
  NEXT
  cString := StrTran(cString,'"','')
ELSE
  FOR i := 1 TO LEN(cDelims)
    cString := Strtran(cString,SubStr(cDelims,i,1),CHR(0))
  NEXT
ENDIF
IF Len(cDelims) > 1
  IF CHR(0)+CHR(0) $ cString
    cString := StrTran(cString,CHR(0)+CHR(0),CHR(0))
  ENDIF
ENDIF
DO WHILE .t.
  nFound := AT(CHR(0),cString)
  IF nFound = 1 //.AND. Len(aTokens)=0
    AADD( aTokens,'' )
    cString := Substr(cString,2)
  ELSEIF nFound > 0
    AADD( aTokens, SubStr(cString,1,nFound-1) )
    cString := SubStr(cString,nFound+1)
  ELSE
    AADD( aTokens, cString )
    EXIT
  ENDIF
ENDDO
RETURN aTokens

/* ----------------------- */

STATIC FUNCTION _DCTokenTrim( cString, cDelims, nLeft, nRight )

LOCAL i, cChar, cOutString := ''
FOR i := 1 TO LEN(cString)
  cChar := SubStr(cString,i,1)
  IF !(cChar$cDelims)
    cOutString := SubStr(cString,i)
    nLeft := i-1
    EXIT
  ENDIF
NEXT
FOR i := LEN(cOutString) TO 1 STEP -1
  cChar := SubStr(cOutString,i,1)
  IF !(cChar$cDelims)
    nRight := LEN(cOutString)-i
    cOutString := SubStr(cOutString,1,i)
    EXIT
  ENDIF
NEXT
RETURN cOutString

/* ----------------------- */

FUNCTION DC_FillChar ( nCharacter )

LOCAL nChar := nFillChar
nFillChar := IIF(Valtype(nCharacter)='N',nCharacter,nFillChar)
RETURN nChar

/* ----------------------- */

STATIC FUNCTION _dctokendelims

RETURN ' ,.;:!?/()#&%+-*'+CHR(0)+CHR(9)+CHR(10)+CHR(13)+CHR(26)

/* ----------------------- */

FUNCTION dc_tokennum( cString, cDelims )

LOCAL nFound, i, nTokens := 0

cDelims := IIF(Valtype(cDelims)='C',cDelims,_DCTokenDelims() )
IF EMPTY(cString)
  RETURN 0
ENDIF
DO WHILE .t.
  nFound := 0
  FOR i := 1 TO LEN(cDelims)
    nFound := AT(SubStr(cDelims,i),cString)
    IF nFound > 0
      EXIT
    ENDIF
  NEXT
  IF nFound > 0
    nTokens++
    cString := SubStr(cString,nFound+1)
  ELSE
    nTokens++
    EXIT
  ENDIF
ENDDO
RETURN nTokens

