#include "simpleio.ch"
#include "asxml.ch"
#INCLUDE "dcdialog.CH"
#INCLUDE "dcads.CH"

#DEFINE CRLF Chr(13)+Chr(10)

#pragma library("asxml10.lib")

FUNCTION DC_Xml2ObjectTree( cXmlFile, lXb2Net )

LOCAL nXMLDoc, nActions, oRootNode, nTag, nHandle, nOutHandle, cXmlText, ;
      cString, lIsString, aXml

DEFAULT lXb2Net := .f.

IF Empty(cXmlFile) .OR. Valtype(cXmlFile) # 'C'
  RETURN nil
ENDIF

IF '<' $ cXmlFile
  cXmlText := cXmlFile
  lIsString := .T.
ELSE
  cXmlText := MemoRead(cXmlFile)
  lIsString := .F.
ENDIF

IF "'" $ cXmlText .AND. !lIsString
  nHandle := DC_TxtOpen(cXmlFile)
  nOutHandle := FCreate(cXmlFile + '.TEMP')
  DO WHILE !DC_TxtEof(nHandle)
    cString := DC_TxtLine(nHandle)
    DC_TxtSkip(nHandle,1)
    cString := Strtran(cString,"'",Chr(255))
    FWrite(nOutHandle,cString+Chr(13)+Chr(10))
  ENDDO
  FClose(nOutHandle)
  FClose(nHandle)
  cXmlFile += '.TEMP'
ENDIF

IF lXb2Net

  aXml := &('xbXML2Array')(cXmlText)

  oRootNode := DC_XmlNode():New('#ROOT')
  DumpTag2( oRootNode, aXml )

ELSE

  IF lIsString
    nXMLDoc := XMLDocOpenString(cXmlText)
  ELSE
    nXMLDoc := XMLDocOpenFile(cXmlFile)
  ENDIF

  IF(nXMLDoc == 0)
    PrintErrors(nXMLDoc)
    RETURN nil
  ENDIF

  nTag := XMLDocGetRootTag(nXMLDoc)

  oRootNode := DumpTag(nTag,1)

  XMLDocClose(nXMLDoc)

ENDIF

IF '.TEMP' $ cXmlFile
  Ferase(cXmlFile)
ENDIF

RETURN oRootNode

* ----------

FUNCTION DC_Xml2Array( cXmlFile, lXb2Net )

LOCAL nXMLDoc, nActions, nTag, nHandle, nOutHandle, cXmlText, ;
      cString, lIsString, aXml[0]

DEFAULT lXb2Net := .f.

IF Empty(cXmlFile) .OR. Valtype(cXmlFile) # 'C'
  RETURN nil
ENDIF

IF '<' $ cXmlFile
  cXmlText := cXmlFile
  lIsString := .T.
ELSE
  cXmlText := MemoRead(cXmlFile)
  lIsString := .F.
ENDIF

IF "'" $ cXmlText .AND. !lIsString
  nHandle := DC_TxtOpen(cXmlFile)
  nOutHandle := FCreate(cXmlFile + '.TEMP')
  DO WHILE !DC_TxtEof(nHandle)
    cString := DC_TxtLine(nHandle)
    DC_TxtSkip(nHandle,1)
    cString := Strtran(cString,"'",Chr(255))
    FWrite(nOutHandle,cString+Chr(13)+Chr(10))
  ENDDO
  FClose(nOutHandle)
  FClose(nHandle)
  cXmlFile += '.TEMP'
ENDIF

IF lXb2Net

  aXml := &('xbXML2Array')(cXmlText)

ELSE

  IF lIsString
    nXMLDoc := XMLDocOpenString(cXmlText)
  ELSE
    nXMLDoc := XMLDocOpenFile(cXmlFile)
  ENDIF

  IF(nXMLDoc == 0)
    PrintErrors(nXMLDoc)
    RETURN nil
  ENDIF

  nTag := XMLDocGetRootTag(nXMLDoc)

  aXml := DumpTagArray(nTag,1)

  XMLDocClose(nXMLDoc)

ENDIF

IF '.TEMP' $ cXmlFile
  Ferase(cXmlFile)
ENDIF

RETURN aXml

* -------------

STATIC FUNCTION DumpTag(nTag,nLevel)

LOCAL aMember, n, oNode, oChildNode

IF !XMLGetTag(nTag, @aMember)
  RETURN nil
ENDIF

IF aMember[XMLTAG_NAME] == '#CDATA'
  IF !Empty(aMember[XMLTAG_CHILD])
    nTag := aMember[XMLTAG_CHILD][1]
    IF !XMLGetTag(nTag,@aMember)
      RETURN nil
    ENDIF
  ELSE
    // RETURN nil
  ENDIF
ELSEIF aMember[XMLTAG_NAME] == '#PCDATA'
  IF !Empty(aMember[XMLTAG_CHILD])
    nTag := aMember[XMLTAG_CHILD][1]
    IF !XMLGetTag(nTag,@aMember)
      RETURN nil
    ENDIF
  ELSE
    RETURN nil
  ENDIF
ENDIF

oNode := DC_XmlNode():new(aMember[XMLTAG_NAME],aMember[XMLTAG_CONTENT], ;
                          aMember[XMLTAG_ATTRIB],aMember[XMLTAG_CHILD])

Sleep(0)

IF aMember[XMLTAG_CHILD] != NIL
  FOR n := 1 TO Len(aMember[XMLTAG_CHILD])
    oChildNode := DumpTag(aMember[XMLTAG_CHILD][n],nLevel++)
    IF !oChildNode == NIL
      oNode:addChild(oChildNode)
    ENDIF
  NEXT
ENDIF

RETURN oNode

* ------------

STATIC FUNCTION DumpTag2( oNode, aXml )

LOCAL oChildNode, i

IF Valtype(aXml) == 'A'
  FOR i := 1 TO Len(aXml)
    IF Valtype(aXml[i,3]) == 'A'
      oChildNode := DC_XmlNode():new(aXml[i,1],nil,aXml[i,2])
      oNode:addChild(oChildNode)
      DumpTag2(oChildNode,aXml[i,3])
    ELSE
      oChildNode := DC_XmlNode():new(aXml[i,1],aXml[i,3],aXml[i,2])
      oNode:addChild(oChildNode)
    ENDIF
  NEXT
ELSE
  oChildNode := DC_XmlNode():new(aXml[1],aXml[3],aXml[2])
  oNode:addChild(oChildNode)
ENDIF

RETURN oNode

* -------------

STATIC FUNCTION DumpTagArray(nTag,nLevel)

LOCAL aMember, n, aArray, aChildArray

IF !XMLGetTag(nTag, @aMember)
  RETURN nil
ENDIF

IF aMember[XMLTAG_NAME] == '#CDATA'
  IF !Empty(aMember[XMLTAG_CHILD])
    nTag := aMember[XMLTAG_CHILD][1]
    IF !XMLGetTag(nTag,@aMember)
      RETURN nil
    ENDIF
  ELSE
    RETURN nil
  ENDIF
ELSEIF aMember[XMLTAG_NAME] == '#PCDATA'
  IF !Empty(aMember[XMLTAG_CHILD])
    nTag := aMember[XMLTAG_CHILD][1]
    IF !XMLGetTag(nTag,@aMember)
      RETURN nil
    ENDIF
  ELSE
    RETURN nil
  ENDIF
ENDIF

aArray := { aMember[XMLTAG_NAME],aMember[XMLTAG_CONTENT], ;
            aMember[XMLTAG_ATTRIB] }

Sleep(0)

IF aMember[XMLTAG_CHILD] != NIL
  FOR n := 1 TO Len(aMember[XMLTAG_CHILD])
    aChildArray := DumpTagArray(aMember[XMLTAG_CHILD][n])
    IF !aChildArray == NIL
      AAdd( aArray, aChildArray )
    ENDIF
  NEXT
ENDIF

RETURN aArray

* -----------

STATIC PROCEDURE PrintErrors(nXmlDoc)

LOCAL n, aErrors := XMLDocGetErrorList(nXMLDoc)

IF aErrors == NIL
    ? "No error descriptions available!"
ELSEIF Valtype(aErrors) == 'A'
  FOR n := 1 TO Len(aErrors)
    /*
     * format and print error message
     */
    ?  aErrors[n, XML_ERROR_FILE]+;
      "("+AllTrim(Str(aErrors[n, XML_ERROR_LINE]))+":"+;
      AllTrim(Str(aErrors[n, XML_ERROR_COLUMN]))+")"+;
      " error XPL00"+AllTrim(Str(aErrors[n, XML_ERROR_ID]))+": "+;
      GetErrorText(aErrors[n, XML_ERROR_ID])
    IF aErrors[n, XML_ERROR_ADDINFO] != NIL
        ? aErrors[n, XML_ERROR_FILE]+;
          "("+AllTrim(Str(aErrors[n, XML_ERROR_LINE]))+":"+;
          AllTrim(Str(aErrors[n, XML_ERROR_COLUMN]))+")"+;
          " info: "+aErrors[n, XML_ERROR_ADDINFO]
    ENDIF
  NEXT
ENDIF

RETURN

* ---------------

STATIC FUNCTION GetErrorText(nError)

STATIC aErrorText := {;
        "out of memory; close some applications and try again",;
        "invalid DTD declaration",;
        "content outside XML tags not allowed",;
        "document has no root tag",;
        "invalid endtag or no endtag found",;
        "expecting string delimiter",;
        "unterminated string",;
        "file not found",;
        "file read error",;
        "missing name of file",;
        "duplicate attribute",;
        "malformed attribute",;
        "invalid name for attribute",;
        "error while processing action codeblock",;
    }

RETURN aErrorText[nError]

* -----------------

CLASS DC_XmlNode

   EXPORTED:

   VAR name
   VAR content
   VAR attrib
   VAR childList
   VAR childTags
   VAR data
   VAR parent
   VAR cargo
   VAR caption

   METHOD Init, AddChild, AddNode, ChildList, Status, FindNode, GetAttr, ;
          TextDump, WriteXML, WriteNode, AsString, NodeToArray

ENDCLASS

* ---------------

METHOD DC_XmlNode:Init( cName, xContent, aAttrib, aChildTags, aData )

LOCAL i, aAttrib2

IF Valtype(aAttrib) == 'C'
  aAttrib := Strtran(aAttrib,Chr(13)+Chr(10),'')
  aAttrib := DC_TokenArray(aAttrib,' ',.t.)
  FOR i := 1 TO Len(aAttrib)
    IF Empty(aAttrib[i])
      ARemove(aAttrib,i)
      i--
      LOOP
    ENDIF
    aAttrib2 := DC_TokenArray(aAttrib[i],'=',.t.)
    aAttrib[i] := aAttrib2
  NEXT
ENDIF

::name := cName
::content := xContent
IF Valtype(::content) = 'C' .AND. Chr(255) $ ::content
  ::content := Strtran(::content,Chr(255),"'")
ENDIF
::attrib := aAttrib
::childList := {}
::childTags := aChildTags
::data := aData
::caption := ::name

RETURN self

* ---------------

METHOD DC_XmlNode:AddChild( oNode )
AAdd(::childList, oNode)
oNode:parent := self
RETURN self

* ---------------

METHOD DC_XmlNode:AddNode( oNode )
AAdd(::childList, oNode)
oNode:parent := self
RETURN self

* ---------------

METHOD DC_XmlNode:Childlist()
RETURN ::childList

* ---------------

METHOD DC_XmlNode:Status()
RETURN 1

* ---------------

METHOD DC_XmlNode:FindNode( acTagName, lMultiple, lSearchSubs )

LOCAL oNode, i, aNodes[0], cTagName, nStart := 1

DEFAULT lMultiple := .F., ;
        lSearchSubs := .f.

oNode := self

IF Valtype(acTagName) == 'A'

  IF DC_XmlNodeFindMode() == 1 .AND. acTagName[1] == self:name
    nStart := 2
  ENDIF

  FOR i := nStart TO Len(acTagName)
    cTagName := acTagName[i]
    oNode := oNode:findNode( cTagName, IIF(i==Len(acTagName),lMultiple,.f.), .t. )
    IF Valtype(oNode) == 'O'
      IF oNode:name == ATail(acTagName)
        RETURN oNode
      ENDIF
    ELSEIF Valtype(oNode) == 'A'
      RETURN oNode
    ELSE
      RETURN nil
    ENDIF
  NEXT
  RETURN nil
ENDIF

FOR i := 1 TO Len(::childList)
  oNode := ::childList[i]
  IF oNode:caption == acTagName .OR. Substr(oNode:caption,At(':',oNode:caption)+1) == acTagName
    IF lMultiple
      AAdd(aNodes,oNode)
    ELSE
      RETURN oNode
    ENDIF
  ELSEIF lSearchSubs
    oNode := oNode:findNode( acTagName,,.t.)
    IF Valtype(oNode) == 'O'
      IF lMultiple
        AAdd(aNodes,oNode)
      ELSE
        RETURN oNode
      ENDIF
    ENDIF
  ENDIF
NEXT

IF Empty(aNodes)
  aNodes := NIL
ENDIF

RETURN aNodes

* ----------

METHOD DC_XmlNode:GetAttr( cAttrName, lRemoveQuotes )

LOCAL aAttr, i, cAttr
DEFAULT lRemoveQuotes := .f.

IF Empty(::attrib)
  RETURN nil
ENDIF
FOR i := 1 TO Len(::attrib)
  IF ::attrib[i,1] == cAttrName
    cAttr := Strtran(::attrib[i,2],Chr(255),"'")
    IF lRemoveQuotes
      IF (Left(cAttr,1) == "'" .AND. Right(cAttr,1) == "'") .OR. ;
         (Left(cAttr,1) == '"' .AND. Right(cAttr,1) == '"')
        cAttr := SubStr(cAttr,2)
        cAttr := SubStr(cAttr,1,Len(cAttr)-1)
      ENDIF
    ENDIF
    RETURN cAttr
  ENDIF
NEXT
RETURN nil

* ---------------

METHOD DC_XmlNode:TextDump( nIndent, cDelim, nLevel )

LOCAL cOutString := '', i

DEFAULT nIndent := 3, ;
        cDelim := ' : ', ;
        nLevel := 0

cOutString += ( Space(nIndent*nLevel) + ::caption + cDelim + XtoC(::content) + CRLF )
IF Valtype(::attrib) == 'A'
  FOR i := 1 TO Len(::attrib)
    cOutString += ( Space(nIndent*(nLevel+1)) + ::attrib[i,1] + cDelim + XtoC(::attrib[i,2]) + CRLF )
  NEXT
ENDIF
FOR i := 1 TO Len(::childList)
  cOutString += ::childList[i]:TextDump( nIndent, cDelim, nLevel+1)
NEXT
cOutString := Strtran(cOutString,Chr(255),"'")
RETURN cOutString

* ----------------

METHOD DC_XmlNode:WriteXML( cFileName, lCanon, lSuppressIndent )

LOCAL nHandle
nHandle := FCreate(cFileName)
IF nHandle <= 0
  RETURN .F.
ENDIF
FWrite(nHandle,'<?xml version="1.0" encoding="UTF-8" ?>'+CRLF)
::writeNode( nHandle,lCanon,lSuppressIndent)
FClose(nHandle)

RETURN .T.

* ----------------

METHOD DC_XmlNode:WriteNode( nHandle, lCanon, lSuppressIndent, nIndent )

LOCAL i, cAttrib := '', lNoIndent := .F., lCloseTag, cLineEnd

DEFAULT nIndent := 0, ;
        lCanon := .f.,;
        lSuppressIndent := .F.

IF lCanon
  cLineEnd := chr(10)
ELSE
  cLineEnd := CRLF
ENDIF

IF !Empty(::attrib)
  IF lCanon
    ASort(::attrib,,,{|a,b|a[1]<b[1]})
  ENDIF
  cAttrib := ' '
  FOR i := 1 TO Len(::attrib)
    cAttrib += ::attrib[i,1] + '="' + Trim(XtoC(::attrib[i,2])) + '" '
  NEXT
  cAttrib := left(cAttrib,len(cAttrib)-1)
ENDIF

lCloseTag := !(Empty(::childList) .AND. ;
               Empty(::data) .AND. ;
               Empty(::content))

FWrite( nHandle, Space(nIndent) + '<' + ::name + cAttrib + ;
                 iif(Empty(::childList) .AND. Empty(::data) .AND. Empty(::content), ;
                     iif(lCanon,'></' + ::name,'/'),'') +  ;
                 '>' + IIF(Empty(::content), cLineEnd, ''))

IF !Empty(::content)
  FWrite( nHandle, Trim(XtoC(::content)) )
  lNoIndent := .T.
ENDIF

IF lSuppressIndent
  nIndent += 0
ELSEIF !lCanon
  nIndent += 2
ELSE
  nIndent += 2
ENDIF

IF !Empty(::data)
  lNoIndent := .F.
  FOR i := 1 TO Len(::data)
    FWrite( nHandle, Space(nIndent) + '<' + ::data[i,1] + '>' + ;
                     Trim(XtoC(::data[i,2])) + '</' + ::data[i,1] + '>' + cLineEnd )
  NEXT
ENDIF

FOR i := 1 TO Len(::childList)
  lNoIndent := .F.
  ::childList[i]:writeNode( nHandle, lCanon, lSuppressIndent, nIndent )
NEXT

IF lSuppressIndent
  nIndent := 0
ELSEIF lNoIndent
  nIndent := 0
ELSE
  nIndent -= 2
ENDIF

IF lCloseTag
  FWrite( nHandle, Space(nIndent) + '</' + ::name + '>' + cLineEnd )
ENDIF

RETURN .T.

* ---------------

METHOD DC_XmlNode:AsString( lCanon, lSuppressIndent, nIndent )

LOCAL i, cAttrib := '', lNoIndent := .F., lCloseTag, cString := '', cVarName, xValue, cLineEnd

DEFAULT nIndent := 0, ;
        lCanon := .F.,;
        lSuppressIndent := .F.

IF lCanon
  cLineEnd := chr(10)
ELSE
  cLineEnd := CRLF
ENDIF

IF !Empty(::attrib)
  IF lCanon
    ASort(::attrib,,,{|a,b|a[1]<b[1]})
  ENDIF
  cAttrib := ' '
  FOR i := 1 TO Len(::attrib)
    cAttrib += ::attrib[i,1] + '="' + Trim(XtoC(::attrib[i,2])) + '" '
  NEXT
  cAttrib := left(cAttrib,len(cAttrib)-1)
ENDIF

lCloseTag := !(Empty(::childList) .AND. ;
               Empty(::data) .AND. ;
               Empty(::content))

cString += Space(nIndent) + '<' + ::name + cAttrib + ;
           iif(Empty(::childList) .AND. Empty(::data) .AND. Empty(::content), ;
               iif(lCanon,'></' + ::name,'/'),'') +  ;
           '>' + IIF(Empty(::content), cLineEnd, '')

IF !Empty(::content)
  cString += Trim(XtoC(::content))
  lNoIndent := .T.
ENDIF

IF lSuppressIndent
  nIndent += 0
ELSEIF !lCanon
  nIndent += 2
ELSE
  nIndent += 2
ENDIF

IF !Empty(::data)
  lNoIndent := .F.
  FOR i := 1 TO Len(::data)
    cString += Space(nIndent) + '<' + ::data[i,1] + '>' + ;
               Trim(XtoC(::data[i,2])) + '</' + ::data[i,1] + '>' + cLineEnd
  NEXT
ENDIF

FOR i := 1 TO Len(::childList)
  lNoIndent := .F.
  cString += ::childList[i]:asString( lCanon, lSuppressIndent, nIndent )
NEXT

IF  lSuppressIndent
  nIndent := 0
ELSEIF lNoIndent
  nIndent := 0
ELSE
  nIndent -= 2
ENDIF

IF lCloseTag
  cString += Space(nIndent) + '</' + ::name + '>' + cLineEnd
ENDIF

RETURN cString

* ---------

METHOD DC_XmlNode:NodeToArray( aArray, lAttribSubArray )

LOCAL i, aChildList := ::childList(), aNodes

DEFAULT lAttribSubArray := .F.

IF !Empty(aChildList)
  aNodes := Array(Len(aChildList))
ENDIF
FOR i := 1 TO Len(aChildList)
  aNodes[i] := Array(0)
  aChildList[i]:nodeToArray(aNodes[i])
NEXT

ASize(aArray,2)
DEFAULT ::name := '', ;
        ::content := ''

aArray[1] := ::name
aArray[2] := IIF(!Empty(aNodes),aNodes,::content)
IF !Empty(::attrib)
  FOR i := 1 TO Len(::attrib)
    IF lAttribSubArray
      AAdd(aArray,::attrib[i])
    ELSE
      ASize(aArray,Len(aArray)+2)
      aArray[Len(aArray)-1] := ::attrib[i,1]
      aArray[Len(aArray)] := ::attrib[i,2]
    ENDIF
  NEXT
ENDIF

RETURN self

* ---------------

FUNCTION DC_WorkArea2Xml( cXmlFile, aStruct, aTags )

LOCAL oRoot, oStructure, oData, oField, oFieldName, oFieldType, i, ;
      oFieldLen, oFieldDec, nSaveRec := RecNo(), oRecord, cFieldName, ;
      xValue, aTagDefault

aTagDefault := { ;
   'Root', ;
   'Structure', ;
   'Field', ;
   'FieldName', ;
   'FieldType', ;
   'FieldLen', ;
   'FieldDec', ;
   'Data', ;
   'Record' }

DEFAULT aStruct := dbStruct(), ;
        aTags := aTagDefault

oRoot := DC_XmlNode():new(aTags[1])

oStructure := DC_XmlNode():new(aTags[2])

oRoot:addNode(oStructure)

FOR i := 1 TO Len(aStruct)
  oField := DC_XmlNode():new(aTags[3])
  oStructure:addNode(oField)
  oFieldName := DC_XmlNode():new(aTags[4],aStruct[i,1])
  oField:addNode(oFieldName)
  oFieldType := DC_XmlNode():new(aTags[5],_TypeDesc(aStruct[i,2]))
  oField:addNode(oFieldType)
  oFieldLen := DC_XmlNode():new(aTags[6],aStruct[i,3])
  oField:addNode(oFieldLen)
  oFieldDec := DC_XmlNode():new(aTags[7],aStruct[i,4])
  oField:addNode(oFieldDec)
NEXT

oData := DC_XmlNode():new(aTags[8])
oRoot:addNode(oData)

dbGoTop()

DO WHILE !Eof()
  oRecord := DC_XmlNode():new(aTags[9])
  oData:addNode(oRecord)
  FOR i := 1 TO Len(aStruct)
    cFieldName := aStruct[i,1]
    xValue := &(cFieldName)
    oField := DC_XmlNode():new(cFieldName,xValue)
    oRecord:addNode(oField)
  NEXT
  dbSkip()
ENDDO

dbGoTo(nSaveRec)

IF !Empty(cXmlFile)
  RETURN oRoot:writeXml(cXmlFile)
ENDIF

RETURN oRoot:asString()

* --------------

STATIC FUNCTION _TypeDesc( cType )

LOCAL cDesc

IF cType = 'C'
  cDesc := 'Character'
ELSEIF cType = 'N'
  cDesc := 'Numeric'
ELSEIF cType = 'D'
  cDesc := 'Date'
ELSEIF cType = 'L'
  cDesc := 'Logical'
ELSEIF cType = 'F'
  cDesc := 'Double'
ELSEIF cType = 'X'
  cDesc := 'Character/Binary'
ELSEIF cType = 'O'
  cDesc := 'Generic'
ELSEIF cType = 'I'
  cDesc := 'Integer'
ELSEIF cType = 'M'
  cDesc := 'Memo/Text'
ELSEIF cType = 'V'
  cDesc := 'Memo/Binary'
ELSEIF cType = 'T'
  cDesc := 'TimeStamp'
ELSEIF cType = 'Y'
  cDesc := 'Currency'
ELSE
  cDesc := 'Unknown'
ENDIF

RETURN cDesc

* ------------

GETSETFUNCTION DC_XmlNodeFindMode DEFAULT 0

* ------------

FUNCTION DC_XmlEscape( cText, lEscape )

DEFAULT lEscape := .t.

IF lEscape
  cText := Strtran( cText, '&', '&amp;' )
  cText := Strtran( cText, '<', '&lt;' )
  cText := Strtran( cText, '>', '&gt;' )
  cText := Strtran( cText, '"', '&quot;' )
  cText := Strtran( cText, "'", '&apos;' )
ELSE
  cText := Strtran( cText, '&amp;', '&' )
  cText := Strtran( cText, '&lt;', '<' )
  cText := Strtran( cText, '&gt;', '>' )
  cText := Strtran( cText, '&quot;', '"' )
  cText := Strtran( cText, '&apos;', "'" )
ENDIF

RETURN cText

* ------------

FUNCTION Xtoc( xVar )

LOCAL cType := ValType(xVar), xRet

DO CASE
      Case cType = "C" .or. cType="M"
         xRet := xVar
      Case cType = "N"
         xRet := Alltrim(Str(xVar))
      Case cType = "D"
         xRet := DtoC(xVar)
      Case cType = "L"
         xRet := If(xVar,"Yes","No ")
      Case cType = "U"
         xRet := ""
ENDCASE
Return xRet



